from os import listdir
import os
import sys
import re

def find_gene_name(data,Chr,R1,R2):
    if data.has_key(Chr):
        for i in data[str(Chr)]:
            temp = i.split("-")
            if int(temp[0]) < int(R1) and int(temp[1]) > int(R2):
                GName = data[str(Chr)][i]
            elif int(temp[0]) > int(R1) and int(temp[1]) > int(R2) and int(temp[0]) > int(R2) :
                GName = "Part of " + data[str(Chr)][i]
            elif int(temp[0]) < int(R1) and int(temp[1]) > int(R2) and int(R1) < int(temp[1]):
                GName = "Part of " + data[str(Chr)][i]
            else:
                GName = "NONE"
    else:
       GName = "NA"

    return GName


"""
 Make Gene range and descriptions from Barley Gene GFF3 file
"""

GFF3_File = "Brachy_mRNA.gff3"
Output_Files = "/mnt/users/jeevka/Mallik/Brachy_Genomics/BLAST_1700_Brachy_Output/"
Subject = "Festuca-1700"
Query = "Brachy"

F1 = open(GFF3_File,"r")
data = {}
for i in F1:
    temp = i.split("\t")
    Grange = str(temp[3]) + "-" + str(temp[4])
    if re.search("product=",temp[8]):
        temp1 = temp[8].split(";")[7]
        Gdes = temp1.split("=")[1]
    else:
        Gdes = "NA"

    if data.has_key(temp[0]):
        data[temp[0]][Grange] = Gdes
    else:
        data[temp[0]] = {Grange: Gdes}

F1.close()

"""
    Open HF and Barley BLAST files
"""
arr = os.listdir(Output_Files)
L = len(arr)
N1 = 0
for i in xrange(L):
    N = i + 1
    """
        Open each file one by one
    """
    Fname = Output_Files + "Seq_" + str(N) + ".out"
    F1 = open(Fname,"r")
    for i in F1:
        N1 += 1
        #print i.strip()
        temp = i.split()
        temp1 = temp[0].split(":")
        Chr = temp1[0];

        if len(temp1) > 1:
            temp2 = temp1[1].split("-")
            R1 = int(temp2[0]) + int(temp[4]); R2 = int(temp2[0]) + int(temp[5])
        else:
            R1 = int(temp[4]); R2 = int(temp[5])

        # Decide strand
        if int(temp[6]) > int(temp[7]):
            strand = "-"
        else:
            strand = "+"

        # Make Range in HF
        T = temp[0].split(":")

        if len(temp1) > 1:
            T1 = T[1].split("-")
            QR1 = int(T1[0]) + int(temp[4])
            QR2 = int(T1[0]) + int(temp[5])
        else:
            QR1 = temp[4]; QR2 = temp[5]

        BRange = str(T[0]) + "-" + str(QR1) + "-" + str(QR2)

        # Range of Barley
        SChr = temp[1]
        SR1 = temp[6]
        SR2 = temp[7]
        OrthoRange = SChr + ":" + SR1 + "-" + SR2

        geneName = find_gene_name(data,SChr,SR1,SR2)

        OName = "Ortho_" + Query + "_" + str(N1)
        txt = Chr + "\t" + Subject + "\t" + "Ortholog\t" + str(QR1) + "\t" + str(QR2)  +"\t.\t" + strand + "\t.\t" + "ID=" + OName + ";Name=" + geneName + ";Note=" + OrthoRange
        print txt

    F1.close()